@echo off

setlocal ENABLEDELAYEDEXPANSION

REM **********************************************
REM Find the java executable
REM **********************************************
where /q java

if ERRORLEVEL 1 (
    if NOT DEFINED java_home (
        echo No Java found on this system.
        exit -10
    ) else (
        SET java_cmd="%java_home%"\bin\java
    )
) else (
    SET java_cmd=java
)

REM **********************************************
REM Check whether we are running java 7/8 or 11
REM **********************************************
for /f "tokens=3" %%g in ('%java_cmd% -version 2^>^&1 ^| findstr /i "version"') do (
        SET "string=%%g"
)

for /F "tokens=1,2 delims=. " %%a in (%string%) do (
   set major=%%a
   set minor=%%b
)

if "%major%" == "1" (
   set java_ver=%minor%
) else (
   set java_ver=%major%
)


set batchDrive=%~d0
%batchDrive%

set batchDir=%~p0
cd %batchDir%
cd ..
set rootDir=%cd%

if NOT DEFINED HOSTNAME for /f %%i in ('hostname') do set HOSTNAME=%%i

REM ****************************************************
REM If java 11 no endorsed dirs an no JAXB or CORBA/RMI
REM We need different parameters
REM ****************************************************
if %java_ver% == 11 (
    set classp="config;lib/endorsed/*;lib/java11/*;lib/*;lib/extra/*"
    set orb="-Dorg.omg.CORBA.ORBClass=org.jacorb.orb.ORB -Dorg.omg.CORBA.ORBSingletonClass=org.jacorb.orb.ORBSingleton"
) else (
    set classp="config:lib/*;lib/extra/*"
    set orb="-Djava.endorsed.dirs=lib/endorsed -Dorg.omg.CORBA.ORBClass=org.jacorb.orb.ORB -Dorg.omg.CORBA.ORBSingletonClass=org.jacorb.orb.ORBSingleton"
)

set derby_cfg=-Dderby.storage.pageSize=4096 -Dderby.storage.pageCacheSize=40
set derby_log=-Dderby.stream.error.file="%rootDir%"\logs\derby.log
set log4j2=
if exist lib\jul-to-slf4j*.jar set log4j2=-Dlog4j2.logEventFactory=com.addc.server.commons.tomcat.JuliLog4jEventFactory

start "${full.service.name}" "%java_cmd%" -server -cp %classp% %log4j2% %orb% %derby_cfg% %derby_log% -Dcatalina.base="%rootDir%" %SRV_OPTS% com.addc.server.ServerRunner ${service.name} > stdout.log 2> logs\error.log


:END

endlocal
